summaryrefslogtreecommitdiff
path: root/home/.oh-my-zsh/plugins/rbw
diff options
context:
space:
mode:
authornavewindre <boneyaard@gmail.com>2025-07-13 06:42:05 +0200
committernavewindre <boneyaard@gmail.com>2025-07-13 06:42:05 +0200
commit02f14a9cb152561a5e44062aac79f3b700403b40 (patch)
tree2db8ebda3b7f6f8777783aeb5c60018e6e1359d8 /home/.oh-my-zsh/plugins/rbw
parentcbbdeb2f6b40a102a829f0c47cff052937231f00 (diff)
omz
Diffstat (limited to 'home/.oh-my-zsh/plugins/rbw')
-rw-r--r--home/.oh-my-zsh/plugins/rbw/README.md22
-rw-r--r--home/.oh-my-zsh/plugins/rbw/rbw.plugin.zsh58
2 files changed, 80 insertions, 0 deletions
diff --git a/home/.oh-my-zsh/plugins/rbw/README.md b/home/.oh-my-zsh/plugins/rbw/README.md
new file mode 100644
index 0000000..cae36ce
--- /dev/null
+++ b/home/.oh-my-zsh/plugins/rbw/README.md
@@ -0,0 +1,22 @@
+# Bitwarden (unofficial) CLI plugin
+
+This plugin adds completion for [rbw](https://github.com/doy/rbw), an unofficial
+CLI for [Bitwarden](https://bitwarden.com).
+
+To use it, add `rbw` to the plugins array in your zshrc file:
+
+```zsh
+plugins=(... rbw)
+```
+
+## `rbwpw`
+
+The `rbwpw` function is a wrapper around `rbw`. It copies the password in the
+clipboard for the service you ask for and clears the clipboard 20s later.
+The usage is as follows:
+
+```zsh
+rbwpw <service>
+```
+
+This plugin does not add any aliases.
diff --git a/home/.oh-my-zsh/plugins/rbw/rbw.plugin.zsh b/home/.oh-my-zsh/plugins/rbw/rbw.plugin.zsh
new file mode 100644
index 0000000..0b55e6e
--- /dev/null
+++ b/home/.oh-my-zsh/plugins/rbw/rbw.plugin.zsh
@@ -0,0 +1,58 @@
+if (( ! $+commands[rbw] )); then
+ return
+fi
+
+# If the completion file doesn't exist yet, we need to autoload it and
+# bind it to `rbw`. Otherwise, compinit will have already done that.
+if [[ ! -f "$ZSH_CACHE_DIR/completions/_rbw" ]]; then
+ typeset -g -A _comps
+ autoload -Uz _rbw
+ _comps[rbw]=_rbw
+fi
+
+rbw gen-completions zsh >| "$ZSH_CACHE_DIR/completions/_rbw" &|
+
+# rbwpw function copies the password of a service to the clipboard
+# and clears it after 20 seconds
+function rbwpw {
+ if [[ $# -ne 1 ]]; then
+ echo "usage: rbwpw <service>"
+ return 1
+ fi
+ local service=$1
+ if ! rbw unlock; then
+ echo "rbw is locked"
+ return 1
+ fi
+ local pw=$(rbw get $service 2>/dev/null)
+ if [[ -z $pw ]]; then
+ echo "$service not found"
+ return 1
+ fi
+
+ # Generate a random identifier for this call to rbwpw
+ # so we can check if the clipboard content has changed
+ local _random="$RANDOM" _cache="$ZSH_CACHE_DIR/.rbwpw"
+ echo -n "$_random" > "$_cache"
+
+ # Use clipcopy to copy the password to the clipboard
+ echo -n $pw | clipcopy
+ echo "password for $service copied!"
+
+ # Clear the clipboard after 20 seconds, but only if the clipboard hasn't
+ # changed (if rbwpw hasn't been called again)
+ {
+ sleep 20 \
+ && [[ "$(<"$_cache")" == "$_random" ]] \
+ && clipcopy </dev/null 2>/dev/null \
+ && command rm -f "$_cache" &>/dev/null
+ } &|
+}
+
+function _rbwpw {
+ local -a services
+ services=("${(@f)$(rbw ls 2>/dev/null)}")
+ [[ -n "$services" ]] && compadd -a -- services
+}
+
+compdef _rbwpw rbwpw